unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, JPEG, VideoCapture, StdCtrls, ExtCtrls, Psock, NMFtp, ComCtrls,
  Menus, inifiles, unit2, SHELLAPI;

const
  dib_name = 'c:\temp\del-me.bmp';     // temporary file name for bitmap image
  jpeg_name = 'c:\temp\del-me.jpg';    // temporary file name for JPEG image

  ConfigFileName = './options.ini';


type


  TMainForm = class(TForm)
    Image1: TImage;
    NMFTP1: TNMFTP;
    Timer1: TTimer;
    ProgressBar1: TProgressBar;
    MainMenu1: TMainMenu;
    Snap1: TMenuItem;
    SetUp1: TMenuItem;
    Hide1: TMenuItem;
    N1: TMenuItem;
    Exit1: TMenuItem;
    procedure NMFTP1Connect(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Snap1Click(Sender: TObject);
    procedure SetUp1Click(Sender: TObject);
    procedure Hide1Click(Sender: TObject);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Exit1Click(Sender: TObject);
  private
     hWndC: THandle;
     pic_width,pic_height:integer;
     CountNow : integer;
     Options : OptionsRec;

     procedure TakePicture;
     procedure LoadOptions;
     procedure SaveOptions;
     function Encrypt(Passwd:string):String;
     function DeCrypt(Jumble:String):String;
     procedure SystemTray(OnOff:DWord);
  public
    { Public declarations }
  end;

var
  MainForm: TMainForm;

implementation

{$R *.dfm}

procedure TMainForm.TakePicture;

const
  dark_font_colour = TColor ($333333);
  light_font_colour = TColor ($cceeee);
  quality = 85;

var
     dib_filename: string;
     jpg: TJPEGImage;
     show_timestamp: boolean;
     bold_timestamp: boolean;
     time_stamp: string;
     i, j: integer;
     x, y: integer;

begin
     Timer1.Enabled := false;
     Snap1.enabled := false;
     CountNow := 0;

     clientwidth := pic_width + (2*Image1.Left);
     clientheight := pic_height + Image1.Top + Image1.Left;

     show_timestamp := true;
     bold_timestamp := true;
     dib_filename := dib_name;

     if (SendMessage (hWndC, WM_CAP_GRAB_FRAME, 0, 0) = 0) then
         begin
         SendMessage (hWndC, WM_CAP_DRIVER_DISCONNECT, 0, 0);
         exit;
         end;

     if (SendMessage (hWndC, WM_CAP_FILE_SAVEDIB, 0, integer (dib_filename)) = 0) then
         begin
         SendMessage (hWndC, WM_CAP_DRIVER_DISCONNECT, 0, 0);
         exit;
         end;


     jpg := TJPEGImage.Create;
     Image1.picture.LoadFromFile (dib_name);
     Image1.Width := Image1.Picture.Width;
     Image1.height := Image1.Picture.height;

     ProgressBar1.Position := (Options.Period div 3) * 2;

     if show_timestamp then                // Add a timestamp to the bitmap
         with Image1.picture.Bitmap.Canvas do
         begin
         Brush.Style := bsClear;           // For a transparent background
         time_stamp := FormatDateTime (' dd-mmm-yyyy  hh:mm:ss ', Now);
         if bold_timestamp then Font.Style := [fsBold];
         Font.Color := dark_font_colour;
         x := 1;
         y := Image1.picture.height - TextHeight ('Cy') - 1;
         for i := -1 to 1 do
             for j := -1 to 1 do
                 TextOut (x + i, y + j, time_stamp);
         Font.Color := light_font_colour;
         TextOut (x, y, time_stamp);
         end;


     jpg.Assign (Image1.picture.Bitmap);         // Load the picture into the JPEG
     jpg.CompressionQuality := quality;
     jpg.SaveToFile (jpeg_name);     // Save the JPEG to a temporary file
     jpg.Free;

     if FileExists (dib_name) then DeleteFile (dib_name);

     NMFTP1.Host := Options.server;
     NMFTP1.UserID := Options.UserName;
     NMFTP1.Password := Options.Password;
     try
         NMFTP1.Connect;
     except
         ProgressBar1.Position := 0;
         Timer1.enabled := true;
         Snap1.enabled := true;
     end;
end;



procedure TMainForm.NMFTP1Connect(Sender: TObject);
begin
     ProgressBar1.Position := (Options.Period div 3);

     NMFTP1.upload(jpeg_name,Options.DestFile);

     NMFTP1.RequestCloseSocket;
     if FileExists (jpeg_name) then DeleteFile (jpeg_name);
     ProgressBar1.Position := 0;
     Timer1.enabled := true;
     Snap1.enabled := true;
end;



procedure TMainForm.Timer1Timer(Sender: TObject);
begin
     if CountNow < Options.Period then
         begin
         CountNow := CountNow + 1;
         ProgressBar1.Position := CountNow;
         exit;
         end;

     CountNow := 0;
     ProgressBar1.Position := CountNow;
     TakePicture;
end;



procedure TMainForm.FormActivate(Sender: TObject);
begin
     if not Timer1.Enabled then
         begin
         LoadOptions;
         ProgressBar1.Max := Options.Period;
         CountNow := Options.Period-1;
         end;

     Timer1.Enabled := true;
end;



procedure TMainForm.FormCreate(Sender: TObject);
var
   nID: integer;
   Handle: THandle;
   bmh: TBitmapInfoHeader;
begin
     Handle := GetDesktopWindow;

     nID := 126;
     pic_width := 320;
     pic_height := 240;
     hWndC := capCreateCaptureWindow ( 'Window', WS_CHILD , 0, 0, pic_width, pic_height, Handle, nID);
     if SendMessage (hWndC, WM_CAP_DRIVER_CONNECT, 0, 0) = 0 then exit;

     with bmh do
         begin
         FillChar (bmh, SizeOf (bmh), 0);
         biSize := SizeOf (bmh);
         biWidth := pic_width;
         biHeight := pic_height;
         biPlanes := 1;
         biBitCount := 8;
         biCompression := BI_RGB;
         end;

     SendMessage (hWndC, WM_CAP_SET_VIDEOFORMAT, SizeOf (bmh), integer (@bmh));

     ProgressBar1.Max := Options.Period;
     CountNow := Options.Period-1;
end;



procedure TMainForm.FormDestroy(Sender: TObject);
begin
     SendMessage (hWndC, WM_CAP_DRIVER_DISCONNECT, 0, 0);
end;

procedure TMainForm.Snap1Click(Sender: TObject);
begin
     TakePicture;
end;




procedure TMainForm.LoadOptions;
var   OptionsFile:TIniFile;
begin
     OptionsFile := TIniFile.Create(ConfigFileName);
     options.UserName := OptionsFile.ReadString('Login','LoginName','');
     options.Password := decrypt(OptionsFile.ReadString('Login','Password','FFFFFF'));
     options.Server := OptionsFile.ReadString('Login','Server','server');
     options.DestFile := OptionsFile.ReadString('Misc','File','/dir/file.jpg');
     options.Period := OptionsFile.ReadInteger('Misc','Period',5*60);
     OptionsFile.Free;
end;



procedure TMainForm.SaveOptions;
var   OptionsFile:TIniFile;
begin
     OptionsFile := TIniFile.Create(ConfigFileName);
     OptionsFile.WriteString('Login','LoginName',options.UserName);
     OptionsFile.WriteString('Login','Password',Encrypt(options.Password));
     OptionsFile.WriteString('Login','Server',options.Server);
     OptionsFile.WriteString('Misc','File',options.DestFile);
     OptionsFile.writeinteger('Misc','Period',options.Period);
     OptionsFile.Free;
end;



function TMainForm.Encrypt(Passwd:string):String;
var loop,x:integer;
    ret:string;
begin
     Randomize;
     RandSeed := Random($ffffffff);
     ret := IntToHex(RandSeed,8);
     for loop := 1 to length(Passwd) do
         begin
         x := ord(Passwd[loop]) xor Random(256);
         ret := ret + IntToHex(x,2);
         end;
     Encrypt := Ret;
end;



function TMainForm.DeCrypt(Jumble:String):String;
var loop,x:integer;
    ret:string;
begin
     RandSeed := StrToInt('$'+copy(Jumble,1,8));
     ret := '';
     loop := 9;
     while loop < length(Jumble) do
         begin
         x := StrToInt('$'+copy(Jumble,loop,2)) xor Random(256);
         ret := ret + chr(x);
         loop := loop + 2;
         end;
     DeCrypt := ret;
end;



procedure TMainForm.SetUp1Click(Sender: TObject);
begin
     Form2.Options := Options;
     if Form2.ShowModal = mrOK then
         begin
         Options := Form2.Options;
         ProgressBar1.Max := Options.Period;
         CountNow := Options.Period-1;
         SaveOptions;
         end;
end;




procedure TMainForm.SystemTray(OnOff:DWord);
var NotifyIcon : TNotifyIconData;
begin
     with NotifyIcon do
          begin
          cbSize := sizeof(NotifyIcon);
          Wnd := Handle;
          uID := 1;
          uFlags := NIF_ICON + NIF_TIP + NIF_MESSAGE;
          uCallbackMessage := WM_MBUTTONUP;
          icon := Application.icon;
          hicon := application.icon.handle;
          StrPCopy(szTip,Caption)
          end;
     Shell_NotifyIcon(OnOff,addr(NotifyIcon));
end;



procedure TMainForm.Hide1Click(Sender: TObject);
begin
     SystemTray(NIM_ADD);
     Visible := false;
end;

procedure TMainForm.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     if (x = WM_LBUTTONDOWN) and not visible then
         begin
         visible := true;
         SystemTray(NIM_DELETE);
         end;
end;


procedure TMainForm.Exit1Click(Sender: TObject);
begin
     Close;
end;

end.

